module Markd::HTMLEntities
  LEGACY_MAPPINGS = {
    "Aacute" => '\u00C1',
    "aacute" => '\u00E1',
    "Acirc"  => '\u00C2',
    "acirc"  => '\u00E2',
    "acute"  => '\u00B4',
    "AElig"  => '\u00C6',
    "aelig"  => '\u00E6',
    "Agrave" => '\u00C0',
    "agrave" => '\u00E0',
    "amp"    => '&',
    "AMP"    => '&',
    "Aring"  => '\u00C5',
    "aring"  => '\u00E5',
    "Atilde" => '\u00C3',
    "atilde" => '\u00E3',
    "Auml"   => '\u00C4',
    "auml"   => '\u00E4',
    "brvbar" => '\u00A6',
    "Ccedil" => '\u00C7',
    "ccedil" => '\u00E7',
    "cedil"  => '\u00B8',
    "cent"   => '\u00A2',
    "copy"   => '\u00A9',
    "COPY"   => '\u00A9',
    "curren" => '\u00A4',
    "deg"    => '\u00B0',
    "divide" => '\u00F7',
    "Eacute" => '\u00C9',
    "eacute" => '\u00E9',
    "Ecirc"  => '\u00CA',
    "ecirc"  => '\u00EA',
    "Egrave" => '\u00C8',
    "egrave" => '\u00E8',
    "ETH"    => '\u00D0',
    "eth"    => '\u00F0',
    "Euml"   => '\u00CB',
    "euml"   => '\u00EB',
    "frac12" => '\u00BD',
    "frac14" => '\u00BC',
    "frac34" => '\u00BE',
    "gt"     => '>',
    "GT"     => '>',
    "Iacute" => '\u00CD',
    "iacute" => '\u00ED',
    "Icirc"  => '\u00CE',
    "icirc"  => '\u00EE',
    "iexcl"  => '\u00A1',
    "Igrave" => '\u00CC',
    "igrave" => '\u00EC',
    "iquest" => '\u00BF',
    "Iuml"   => '\u00CF',
    "iuml"   => '\u00EF',
    "laquo"  => '\u00AB',
    "lt"     => '<',
    "LT"     => '<',
    "macr"   => '\u00AF',
    "micro"  => '\u00B5',
    "middot" => '\u00B7',
    "nbsp"   => '\u00A0',
    "not"    => '\u00AC',
    "Ntilde" => '\u00D1',
    "ntilde" => '\u00F1',
    "Oacute" => '\u00D3',
    "oacute" => '\u00F3',
    "Ocirc"  => '\u00D4',
    "ocirc"  => '\u00F4',
    "Ograve" => '\u00D2',
    "ograve" => '\u00F2',
    "ordf"   => '\u00AA',
    "ordm"   => '\u00BA',
    "Oslash" => '\u00D8',
    "oslash" => '\u00F8',
    "Otilde" => '\u00D5',
    "otilde" => '\u00F5',
    "Ouml"   => '\u00D6',
    "ouml"   => '\u00F6',
    "para"   => '\u00B6',
    "plusmn" => '\u00B1',
    "pound"  => '\u00A3',
    "quot"   => "\"",
    "QUOT"   => "\"",
    "raquo"  => '\u00BB',
    "reg"    => '\u00AE',
    "REG"    => '\u00AE',
    "sect"   => '\u00A7',
    "shy"    => '\u00AD',
    "sup1"   => '\u00B9',
    "sup2"   => '\u00B2',
    "sup3"   => '\u00B3',
    "szlig"  => '\u00DF',
    "THORN"  => '\u00DE',
    "thorn"  => '\u00FE',
    "times"  => '\u00D7',
    "Uacute" => '\u00DA',
    "uacute" => '\u00FA',
    "Ucirc"  => '\u00DB',
    "ucirc"  => '\u00FB',
    "Ugrave" => '\u00D9',
    "ugrave" => '\u00F9',
    "uml"    => '\u00A8',
    "Uuml"   => '\u00DC',
    "uuml"   => '\u00FC',
    "Yacute" => '\u00DD',
    "yacute" => '\u00FD',
    "yen"    => '\u00A5',
    "yuml"   => '\u00FF',
  }
end
